Gecode::Int::Count::EqView< VX, VY, VZ, shr, dom > Class Template Reference
Other available functionality » Integer propagators

Propagator for counting views (equal to number of equal views) More...

`#include <count.hh>`

## Public Member Functions

| EqView (Home home, ViewArray< VX > &x, VY y, VZ z, int c)
| Constructor for creation.
virtual Actor * | copy (Space &home)
| Create copy during cloning.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
Public Member Functions inherited from Gecode::Int::Count::ViewBase< VX, VY, VZ >
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual void | reschedule (Space &home)
| Schedule function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< VX > &x, VY y, VZ z, int c)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| EqView (Space &home, EqView &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Int::Count::ViewBase< VX, VY, VZ >
| ViewBase (Space &home, ViewBase &p)
| Constructor for cloning p.
| ViewBase (Home home, ViewArray< VX > &x, VY y, VZ z, int c)
| Constructor for creation.
void | count (Space &home)
| Count how many views are equal now.
int | atleast (void) const
| How many views are at least equal.
int | atmost (void) const
| How many views are at most equal.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Additional Inherited Members

Static Protected Member Functions inherited from Gecode::Int::Count::ViewBase< VX, VY, VZ >
static bool | sharing (const ViewArray< VX > &x, const VY &y, const VZ &z)
| Test whether there is sharing of z with x or y.
Protected Attributes inherited from Gecode::Int::Count::ViewBase< VX, VY, VZ >
ViewArray< VX > | x
| Views still to count.
VY | y
| View to compare to.
VZ | z
| View which yields result of counting.
int | c
| Number of views which are equal and have been eliminated.

## Detailed Description

template<class VX, class VY, class VZ, bool shr, bool dom>
class Gecode::Int::Count::EqView< VX, VY, VZ, shr, dom >

Propagator for counting views (equal to number of equal views)

Not all combinations of views are possible. The types VX and VY must be either equal, or VY must be ConstIntView, ZeroIntView, or IntSet.

Requires

#include <gecode/int/count.hh>
count.hh

Definition at line 309 of file count.hh.

## Constructor & Destructor Documentation

## EqView() [1/2]

template<class VX, class VY, class VZ, bool shr, bool dom>

Gecode::Int::Count::EqView< VX, VY, VZ, shr, dom >::EqView | ( | Space & | home,
|  | EqView< VX, VY, VZ, shr, dom > & | p )

inline protected

Constructor for cloning p.

Definition at line 59 of file view-eq.hpp.

## EqView() [2/2]

template<class VX, class VY, class VZ, bool shr, bool dom>

Gecode::Int::Count::EqView< VX, VY, VZ, shr, dom >::EqView | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | VY | y,
|  | VZ | z,
|  | int | c )

inline

Constructor for creation.

Definition at line 38 of file view-eq.hpp.

## Member Function Documentation

## copy()

template<class VX, class VY, class VZ, bool shr, bool dom>

Actor * Gecode::Int::Count::EqView< VX, VY, VZ, shr, dom >::copy | ( | Space & | home | ) |

virtual

Create copy during cloning.

Implements Gecode::Actor.

Definition at line 64 of file view-eq.hpp.

## propagate()

template<class VX, class VY, class VZ, bool shr, bool dom>

ExecStatus Gecode::Int::Count::EqView< VX, VY, VZ, shr, dom >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 70 of file view-eq.hpp.

## post()

template<class VX, class VY, class VZ, bool shr, bool dom>

ExecStatus Gecode::Int::Count::EqView< VX, VY, VZ, shr, dom >::post | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | VY | y,
|  | VZ | z,
|  | int | c )

static

Post propagator for .

Definition at line 44 of file view-eq.hpp.

The documentation for this class was generated from the following files:

- gecode/int/count.hh
- gecode/int/count/view-eq.hpp